package ru.dbotthepony.kstarbound.io.json

import com.google.gson.TypeAdapter
import com.google.gson.stream.JsonReader
import com.google.gson.stream.JsonWriter
import ru.dbotthepony.kvector.vector.ndouble.Vector2d
import ru.dbotthepony.kvector.vector.nfloat.Vector2f
import ru.dbotthepony.kvector.vector.nint.Vector2i

object Vector2iTypeAdapter : TypeAdapter<Vector2i>() {
	override fun write(out: JsonWriter, value: Vector2i) {
		`out`.beginArray()
		`out`.value(value.x)
		`out`.value(value.y)
		`out`.endArray()
	}

	override fun read(`in`: JsonReader): Vector2i {
		`in`.beginArray()

		val x = `in`.nextInt()
		val y = `in`.nextInt()

		`in`.endArray()

		return Vector2i(x, y)
	}
}

object Vector2fTypeAdapter : TypeAdapter<Vector2f>() {
	override fun write(out: JsonWriter, value: Vector2f) {
		`out`.beginArray()
		`out`.value(value.x)
		`out`.value(value.y)
		`out`.endArray()
	}

	override fun read(`in`: JsonReader): Vector2f {
		`in`.beginArray()

		val x = `in`.nextDouble().toFloat()
		val y = `in`.nextDouble().toFloat()

		`in`.endArray()

		return Vector2f(x, y)
	}
}

object Vector2dTypeAdapter : TypeAdapter<Vector2d>() {
	override fun write(out: JsonWriter, value: Vector2d) {
		`out`.beginArray()
		`out`.value(value.x)
		`out`.value(value.y)
		`out`.endArray()
	}

	override fun read(`in`: JsonReader): Vector2d {
		`in`.beginArray()

		val x = `in`.nextDouble()
		val y = `in`.nextDouble()

		`in`.endArray()

		return Vector2d(x, y)
	}
}
